add to about me
[iankelling.org] / setup.sh
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see <http://www.gnu.org/licenses/>.
16
17 # This script depends on a few other git repos of mine, such as
18 # distro-functions, basic-https-conf, acme-tiny-wrapper
19
20 set -eE -o pipefail
21 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
22
23 usage() {
24 cat <<EOF
25 Usage: ${0##*/} [OPTIONS] [DOMAIN_NAME]
26 Setup dependencies, apache, and gitweb. Then call build.rb.
27
28 Default DOMAIN_NAME is iankelling.org. Domain is expected to resolve
29 so we can get a let's encrypt cert.
30
31 -p PORT Apache port, default is *:443.
32 -h|--help Print help and exit.
33
34 Note: Uses GNU getopt options parsing style
35 EOF
36 exit $1
37 }
38
39 ##### begin command line parsing ########
40
41 port="*:443"
42 temp=$(getopt -l help, p:h "$@") || usage 1
43 eval set -- "$temp"
44 while true; do
45 case $1 in
46 -p) port=$2; shift 2 ;;
47 -h|--help) usage ;;
48 --) shift; break ;;
49 *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
50 esac
51 done
52
53 ##### end command line parsing ########
54
55 x="$(readlink -f "$BASH_SOURCE")"
56 script_dir=${x%/*}
57 cd $script_dir
58
59 domain=${1:-iankelling.org} # use argument for testing site
60 gitroot=/a/bin/githtml
61
62 if [[ $EUID != 0 ]]; then
63 s=sudo
64 fi
65
66 deb8=false
67 if grep -xFq 'VERSION_ID="8"' /etc/os-release; then
68 deb8=true
69 fi
70
71 shopt -s extglob
72
73 type -P a2enmod &>/dev/null || $s apt-get -y install apache2
74 type -P sqlite3 &>/dev/null || $s apt-get -y install sqlite3
75
76
77 acme-tiny-wrapper $domain
78
79 pkgs=(
80 # build.rb dependencies
81 ruby-pygments.rb ruby-safe-yaml ruby-sass
82 # python pkgs used for o(n^2) voting blog entry
83 python-bcrypt python-passlib
84 # gitweb pkgs
85 gitweb highlight
86 )
87 if $deb8; then
88 pkgs+=(build-essential ruby-dev)
89 else
90 pkgs+=(ruby-redcarpet)
91 fi
92
93 $s apt-get -y install ${pkgs[@]}
94 if $deb8; then
95 sudo gem install redcarpet
96 fi
97 chmod og+x _site/on2vote/vote.py
98
99
100 # debian has the package gitweb, which seems to mainly
101 # have some example apache config, and a minimal gitweb config.
102 # I'll just use the config as example and not use the package.
103 # It's example apache config seems to say we can use cgi or cgid,
104 # and googling cgid it seems a newer faster alternative. I also
105 # depend on this in my o(n^2) python script.
106 $s a2enmod cgid
107
108
109 # additional settings from browsing https://git-scm.com/docs/gitweb.conf
110 $s dd of=/etc/gitweb.conf <<EOF
111 \$feature{'highlight'}{'default'} = [1];
112 # highlighting doesn't work on files without extension.
113 # I noticed in terminal "highlight file" won't do it (unknown file type)
114 # hightlight < file will do it, and it's online documentation
115 # suggests it reads shebang. Todo: file a bug for gitweb
116 # to make highlight read shebangs.
117 our \$projectroot = "$gitroot";
118 # not documented at https://git-scm.com/docs/gitweb.conf,
119 # but it's in the debian conf, so use it.
120 # directory to use for temp files.
121 our \$git_temp = "/tmp";
122 push @git_base_url_list, "https://$domain/git";
123 our @extra_breadcrumbs = (
124 [ '$domain' => '/' ],
125 );
126 our \$home_link_str = 'git';
127 our \$site_footer = '$PWD/_site/gitweb-footer.html';
128 push @stylesheets, "/css/gitweb-site.css";
129 our \$favicon = '/assets/favicon.png';
130 # default is 25, cuts off descriptions.
131 our \$projects_list_description_width = 40;
132 # a bit superflous since they are all me
133 our \$omit_owner = true;
134 # highlight scripts with no extension, uses a patch
135 # that is on it's way upstream.
136 our \$highlight_force = 1;
137 EOF
138
139 apache-site -p $port - $domain <<EOF
140 # to run python script on my site:
141 <Directory /var/www/$domain/html/on2vote>
142 # to run python scripts with cgi
143 Options +ExecCGI
144 AddHandler cgi-script .py
145 </Directory>
146
147 <Directory "/var/www/$domain/html/cgi">
148 Options +ExecCGI
149 SetHandler cgi-script
150 </Directory>
151
152 # redirect some old paths when I was using jekyll.
153 Redirect permanent /10-14-2014/On2-vote-results.html /blog/on2-vote-results.html
154 Redirect permanent /09-29-2014/say-On2.html /blog/say-on2.html
155 Redirect permanent /08-07-2014/uninstalling-setup.html /blog/python-uninstall.html
156 Redirect permanent /08-01-2014/publising-my-technical-notes.html /blog/publishing-my-technical-notes.html
157
158 # All below is for gitweb + git-http-web.
159 # A simple builtin way to have a read only git website.
160 # I didn't find any significantly better alternatives out there.
161 SetEnv GIT_PROJECT_ROOT $gitroot
162 SetEnv GIT_HTTP_EXPORT_ALL
163
164 # note: cgi scripts can go anywhere into the filesystem,
165 # so there is no need to do a directory block for $gitroot
166
167 # fot git-http-web
168 <Directory /usr/lib/git-core>
169 AllowOverride None
170 Require all granted
171 </Directory>
172
173 <Directory /usr/share/gitweb>
174 Options +FollowSymLinks +ExecCGI
175 AddHandler cgi-script .cgi
176 </Directory>
177
178 # from man-git-http-backend, so git-http-web ang gitweb can both be used.
179 # it is instead of this:
180 # #ScriptAlias / /usr/lib/git-core/git-http-backend/
181 ScriptAliasMatch \\
182 "(?x)^/git/(.*/(HEAD | \\
183 info/refs | \\
184 objects/(info/[^/]+ | \\
185 [0-9a-f]{2}/[0-9a-f]{38} | \\
186 pack/pack-[0-9a-f]{40}\\.(pack|idx)) | \\
187 git-(upload|receive)-pack))\$" \\
188 /usr/lib/git-core/git-http-backend/\$1
189
190
191
192 # man-git-http-backend claims we should do this, but
193 # it causes no css/images to be displayed. Instead,
194 # just stick with the standard gitweb example directive
195 # from debian.
196 #ScriptAlias /git /usr/share/gitweb/gitweb.cgi/
197 Alias /git /usr/share/gitweb
198 EOF
199
200
201
202 $script_dir/gitweb-descriptions $gitroot
203
204 $script_dir/build.rb
205 $s rm -rf /var/www/$domain/html
206 $s ln -sT $script_dir/_site /var/www/$domain/html